package be.iminds.ilabt.jfed.rspec_fx.parser;

import be.iminds.ilabt.jfed.rspec.model.RspecFactory;
import be.iminds.ilabt.jfed.rspec_fx.model.javafx_impl.FXRspecFactory;
import be.iminds.ilabt.jfed.rspec.parser.TestRspecReconstructable;
import be.iminds.ilabt.jfed.rspec.parser.TestRspecsLibrary;
import be.iminds.ilabt.jfed.rspec_fx.util.JavaFXInitializer;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.testng.annotations.BeforeSuite;
import org.testng.annotations.Factory;
import org.testng.annotations.Test;

/**
 * TestRspecReconstrutableFX
 */
public class TestRspecReconstructableFX extends TestRspecReconstructable {
    private final static Logger LOG = LoggerFactory.getLogger(TestRspecReconstructableFX.class);


    /////////////////////////////////////////////////////////////////////////////////////////////////////////////
    //// get JavaFX initialised before these tests //////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////
    @BeforeSuite
    private static void setupJavaFx() throws InterruptedException {
        JavaFXInitializer.initialize();
    }

    /////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////

    private static RspecFactory fxRspecFactory = FXRspecFactory.getInstance();

    public TestRspecReconstructableFX() {
        super(fxRspecFactory);
    }


    @Factory
    public static Object[] createReconstructableTests() {
        return createReconstructableTestsInternal(fxRspecFactory, ReconstructableTest::new);
    }


    @Test
    public void testRspecRecorderCommand() throws Throwable {
        TestRspecReconstructable.testXmlStaxReconstructable(TestRspecsLibrary.requestWithCommandsAndBarriersPreStaxFormat, fxRspecFactory);
    }
}
